#ifndef PIGMENTBOX_H
#define PIGMENTBOX_H

#include "commtypes.h"
#include "commdefs.h"
#include "refcounter.h"

#include <QFrame>
#include "iPigmentMixture.h"
#include "iSkin.h"

enum eColorPaintMode {
    PAINT_SIMPLE,
    PAINT_KM
};


class PigmentBox : public QFrame {
    Q_OBJECT;

public:
     PigmentBox (QWidget * parent, ISkin * skin = NULL);
    ~PigmentBox (void);

    void setPigment (IPigmentMixture * pig);

    /**
     * Set the box orientation.
     */
    virtual void setVertical (bool v) {
        m_Orientation = v;
        if (!m_Orientation) {
            setMinimumSize  (24, 16);
            setMaximumSize  (24, 16);
        } else {
            setMinimumSize  (16, 24);
            setMaximumSize  (16, 24);
        }
    }

    IPigmentMixture * pigment (void) {
        return m_Pigment;
    }

signals:
    void touched            (IPigmentMixture * pig, float amount);
    void editPigmentRequest (PigmentBox * box);

protected:
    eColorPaintMode m_PaintMode;

    void paintEvent        (QPaintEvent * e);
    void mouseReleaseEvent (QMouseEvent * e);
    void mousePressEvent   (QMouseEvent * e);
    void mouseMoveEvent    (QMouseEvent * e);
    void tabletEvent       (QTabletEvent * event);
    void leaveEvent        (QEvent * event);

private:
    IPigmentMixture * m_Pigment;
    ISkin           * m_Skin;

    bool              m_Orientation;
    bool              m_Dragging;
};

#endif // PIGMENTBOX_H
