/***************************************************************************
 *  Copyright (C) 2009 by Anton R. <commanderkyle@gmail.com>
 *
 *  This file is a part of QAquarelle project.
 *
 *  QAquarelle is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  QAquarelle is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with QAquarelle.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef WORKER_PARAMS_H
#define WORKER_PARAMS_H

#include "iArray.h"
#include "iCanvas.h"


struct sWorkerParameters {
    float     gravity[2];
    float     granulation;
    float     paper_offset[2];
    float     paper_scale[2];
    float     flow_speed;

    volatile int  scanPatch;
    volatile bool scanIdle;

    sPaper         * paper;
    ICanvas        * canvas;
    IPaintingStyle * paint;
};

#endif // WORKER_PARAMS_H
